"""
Replace all occurences of <scriptName> with your chosen script name
Copy and paste code into notepad and save as <scriptName>.py (* All file giveTypes)
Upload file to .../addons/eventcripts/<scriptName>/
Add the following line to your autoexec.cfg:
es_load <scriptName>
Restart your server
Requires EventScripts v2.0.0.250i -> http://Mattie.info/Cs
"""

''' Module Imports '''
import path
import time

''' Eventscript Imports '''
import cfglib
import es
import gamethread

''' Addon Information '''
info = es.AddonInfo()
info.name = "Server Restart"
info.version = "1.0"
info.basename = (__name__.split(".", 1)[~0].replace(".", "/"))
info.author = "aDz"
info.description = "EventScripts v2.0.0.250i Addon: Server Restart"

''' Variable Declarations '''
filePath = es.getAddonPath(info.basename)

''' Configuration '''
cfg = cfglib.AddonCFG(filePath + "/%s.cfg" % info.basename)
cfg.text("%s [v%s] Configuration" %(info.name, info.version))
cfg.text("")
cfg.text("General Settings")
restartTime = cfg.cvar("%s_restartTime" % info.basename, "03", "2-Digit Restart Hour: 24 Hour (String) [Default=\"03\"]")
cfg.write()

''' Wrapping Functions '''
def getTime(directive):
    return time.strftime(directive)
    
def handleFile(text):
    f = open(filePath + "/%s.txt" % info.basename, "a")
    f.write(text)
    f.close() 
    
def msg(text):
    es.msg("#multi", "#lightgreen%s #green[v%s] #default:: %s" %(info.name, info.version, text))

''' Necessary Functions '''    
def load():
    msg("Loaded.")
    handleFile("[%s] Script Loaded :: %s\n" %(getTime("%H:%M:%S"), getTime("%A, %d %B %Y")))    
    checkTime()
        
def unload():
    msg("Unloaded.")
    handleFile("[%s] Script Unloaded :: %s\n" %(getTime("%H:%M:%S"), getTime("%A, %d %B %Y")))

''' Custom Functions '''
def checkTime():
    f = open(filePath + "/%s.txt" % info.basename, "rb")
    if not str(getTime("%Y (%j)")) in f.read():
        f.close()
        if str(getTime("%H")) == restartTime:
            handleFile("[%s] Server Restarted :: %s\n" %(getTime("%H:%M:%S"), getTime("%A, %d %B %Y (%j)")))
            restartServer()
        else:
            gamethread.delayed(3600, checkTime)
    else:
        f.close()
        gamethread.delayed(3600, checkTime)
        
def restartServer():
    msg("Server Restarting -> 10 Seconds...")
    msg("Please Bookmark Ip :: %s:%s" %(str(es.ServerVar("ip")), str(es.ServerVar("hostport"))))
    gamethread.delayed(8, msg, ("SERVER RESTARTING"))
    try:
        raise WindowsError
        windows = True
    except:
        windows = False
    if not windows:
        gamethread.delayed(10, os.system, ("sleep 30; %s; cd ..; ./srcds_run -some parameters" % es.ServerVar("eventscripts_gamedir")))
    else:
        gamethread.delayed(10, es.server.queuecmd, ("_restart"))